cart/urls.py
from django.urls import path
from . import views

app_name = 'cart'

urlpatterns = [
    path('', views.cart, name='cart'),
    path('add/<int:product_id>', views.cart_add, name='cart_add'),
    path('remove/<int:product_id>', views.cart_remove, name='cart_remove'),
    path('update/', views.cart_update, name='cart_update')
]

company/urls.py
from django.urls import path
from . import views

app_name = 'company'

urlpatterns = [
    path('', views.home, name='home'),
    path('about/', views.about, name='about')
]

core/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static
from core import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('company.urls', namespace='company')),
    path('shop/', include('shop.urls', namespace='shop')),
    path('accounts/', include('accounts.urls', namespace='accounts')),
    path('cart/', include('cart.urls', namespace='cart')),
    path('orders/', include('orders.urls', namespace='orders')),
    path('checkout/', include('checkout.urls', namespace='checkout')),
]

orders/urls.py
from django.urls import path
from . import views

app_name = 'orders'
urlpatterns = [
    path('create/', views.order_create, name='create'),
    path('<int:order_id>/', views.detail, name='detail'),
    path('apply/<int:order_id>', views.coupon_apply, name='coupon_apply'),
]

shop/urls.py
from django.urls import path
from . import views

app_name = 'shop'

urlpatterns = [
    path('', views.shop, name='shop'),
    path('search/', views.search, name='search'),
    path('category/<slug:slug>/', views.shop, name='category_filter'),
    path('manufacturer/<slug:slug>/', views.shop, name='manufacturer_filter'),
    path('product_details/<slug:slug>/', views.product_details, name='product'),
    path('review/<slug:slug>/', views.add_review, name='review'),
    path('wishlist/', views.liked, name='liked'),
    path('add-to-wishlist/', views.add_to_wishlist, name='add_to_wishlist'),  # For add to wishlist
]

cart/models.py
from django.db import models

# Create your models here.

cart/forms.py
from django import forms


class CartAddForm(forms.Form):
    quantity = forms.IntegerField(min_value=1, max_value=9, initial=1, widget=forms.NumberInput(
        attrs={'class': 'input-number', 'data-min': 1, 'data-max': 9}))

cart/views.py
from django.shortcuts import render, get_object_or_404, redirect
from .cart import Cart
from .forms import CartAddForm
from shop.models import Product
from django.views.decorators.http import require_POST


def cart(request):
    cart = Cart(request)
    form = CartAddForm()
    return render(request, 'cart/cart.html', {'cart': cart, 'form': form})


@require_POST
def cart_add(request, product_id):
    cart = Cart(request)
    product = get_object_or_404(Product, id=product_id)
    form = CartAddForm(request.POST)
    print(form)
    if form.is_valid():
        cd = form.cleaned_data
        cart.add(product=product, quantity=cd['quantity'])
    else:
        print('helllo')
        cart.add(product=product, quantity=1)
    return redirect('cart:cart')


def cart_remove(request, product_id):
    cart = Cart(request)
    product = get_object_or_404(Product, id=product_id)
    cart.remove(product)
    return redirect('cart:cart')


def is_ajax(request):
    return request.META.get('HTTP_X_REQUESTED_WITH') == 'XMLHttpRequest'


def cart_update(request):
    if is_ajax(request=request) and request.POST and 'attr_id' in request.POST:
        cart = Cart(request)
        print('hekeeooe')
        product = get_object_or_404(Product, id=int(request.POST['attr_id']))
        cart.update(product=product, quantity=int(request.POST['quantity']))
    else:
        print("No Product is Found")
    return redirect('cart:cart')

cart/templates/cart/cart.html
{% extends 'base.html' %}
{% load static %}
{%block content %}

	<!-- Breadcrumbs -->
	<div class="breadcrumbs">
		<div class="container">
			<div class="row">
				<div class="col-12">
					<div class="bread-inner">
						<ul class="bread-list">
							<li><a href="{% url 'company:home' %}">Home<i class="ti-arrow-right"></i></a></li>
							<li class="active">Cart</li>
						</ul>
					</div>
				</div>
			</div>
		</div>
	</div>
	<!-- End Breadcrumbs -->
	{% if cart|length%}
	<!-- Shopping Cart -->
	<div class="shopping-cart section">
		<div class="container">
			<div class="row">
				<div class="col-12">
					<!-- Shopping Summery -->
					<table class="table shopping-summery">
						<thead>
							<tr class="main-hading">
								<th>PRODUCT</th>
								<th>NAME</th>
								<th class="text-center">UNIT PRICE</th>
								<th class="text-center">QUANTITY</th>
								<th class="text-center">TOTAL</th>
								<th class="text-center"><i class="ti-trash remove-icon"></i></th>
							</tr>
						</thead>
						<tbody>
						{% for item in cart %}
							<tr id="product_cart">
								<td class="image" data-title="No"><img src="{{ item.product.images.first.image.url }}" alt="#"></td>
								<td class="product-des" data-title="Description">
									<p class="product-name"><a href="#">{{ item.product }}</a></p>
									<p class="product-des">{{ item.product.short_descriptions }}</p>
								</td>
								<td class="price" data-title="Price"><span>${{ item.price }}</span></td>
								<td class="qty" data-title="Qty"><!-- Input Order -->
									<div class="input-group">
										<input type="text" name="quant[1]" id="cart_value" class="input-number"  data-min="1" data-max="9" value="{{ item.quantity }}" attr_id="{{item.product.pk}}" action_url="{% url 'cart:cart_update' %}" attr_value="{{ item.quantity }}">
									</div>
									<!--/ End Input Order -->
								</td>
								<td class="total-amount" data-title="Total"><span>${{ item.total_price }}</span></td>
								<td class="action" data-title="Remove"><a href="{% url 'cart:cart_remove' item.product.id %}"><i class="ti-trash remove-icon"></i></a></td>
							</tr>
						{% endfor %}
						</tbody>
					</table>
					<!--/ End Shopping Summery -->
				</div>
			</div>
			<div class="row">
				<div class="col-12">
					<!-- Total Amount -->
					<div class="total-amount">
						<div class="row">
							<div class="col-lg-8 col-md-5 col-12">
								<h6>you can update your product quantity .</h6>
							</div>
							<div class="col-lg-4 col-md-7 col-12">
								<div class="right">
									<ul>
										<li>Cart Subtotal<span>${{ cart.get_total_price }}</span></li>
										<li>Shipping<span>Free</span></li>
										<li class="last">You Pay<span>${{ cart.get_total_price }}</span></li>
									</ul>
									<div class="button5">
										<a href="{% url 'cart:cart' %}" class="btn">Update Cart</a>
										<a href="{% url 'orders:create' %}" class="btn">Next</a>
										<a href="{% url 'shop:shop' %}" class="btn">Continue shopping</a>
									</div>
								</div>
							</div>
						</div>
					</div>
					<!--/ End Total Amount -->
				</div>
			</div>
		</div>
	</div>
	<!--/ End Shopping Cart -->
	{%else%}
	    <div class="container" style="margin-top:100px">
        <div class="row">
            <div class="col-12">
                <div class="section-title">
                    <h2>Your Cart is empty...!</h2>
                </div>
				<div class="section-title">
					<h6><a style="color:red" href="{% url 'shop:shop'%}">Go to Shop <i class="ti-arrow-right"></i></a>
					</h6>
				</div>
            </div>
        </div>
	</div>
	{% endif %}

	<!-- Start Shop Services Area  -->
	<section class="shop-services section">
		<div class="container">
			<div class="row">
				<div class="col-lg-3 col-md-6 col-12">
					<!-- Start Single Service -->
					<div class="single-service">
						<i class="ti-rocket"></i>
						<h4>Free shiping</h4>
						<p>Orders over $100</p>
					</div>
					<!-- End Single Service -->
				</div>
				<div class="col-lg-3 col-md-6 col-12">
					<!-- Start Single Service -->
					<div class="single-service">
						<i class="ti-reload"></i>
						<h4>Free Return</h4>
						<p>Within 30 days returns</p>
					</div>
					<!-- End Single Service -->
				</div>
				<div class="col-lg-3 col-md-6 col-12">
					<!-- Start Single Service -->
					<div class="single-service">
						<i class="ti-lock"></i>
						<h4>Sucure Payment</h4>
						<p>100% secure payment</p>
					</div>
					<!-- End Single Service -->
				</div>
				<div class="col-lg-3 col-md-6 col-12">
					<!-- Start Single Service -->
					<div class="single-service">
						<i class="ti-tag"></i>
						<h4>Best Peice</h4>
						<p>Guaranteed price</p>
					</div>
					<!-- End Single Service -->
				</div>
			</div>
		</div>
	</section>
	<br>
	<br>
	<br>
	<!-- End Shop Newsletter -->


{% endblock %}
{% block footer %}
<script src="{% static 'cart/js/active.js' %}"></script>
<script src="{% static 'frontend/js/jquery.cookie.min.js' %}"></script>
{% endblock%}